diff --git a/drivers/media/i2c/hm11b1.c b/drivers/media/i2c/hm11b1.c
index ecb2c19583ae..7852f31685f8 100644
--- a/drivers/media/i2c/hm11b1.c
+++ b/drivers/media/i2c/hm11b1.c
@@ -42,16 +42,20 @@
 
 /* Analog gain controls from sensor */
 #define HM11B1_REG_ANALOG_GAIN		0x0205
+#define HM11B1_REG_ANALOG_GAIN_IR	0x0206
 #define HM11B1_ANAL_GAIN_MIN		0
-#define HM11B1_ANAL_GAIN_MAX		0x50
+#define HM11B1_ANAL_GAIN_MAX		0xFF
 #define HM11B1_ANAL_GAIN_STEP		1
 
 /* Digital gain controls from sensor */
 #define HM11B1_REG_DGTL_GAIN		0x0207
+#define HM11B1_REG_DGTL_GAIN_IR		0x0209
 #define HM11B1_DGTL_GAIN_MIN		0x0
-#define HM11B1_DGTL_GAIN_MAX		0x0200
+#define HM11B1_DGTL_GAIN_MAX		0x3FF
 #define HM11B1_DGTL_GAIN_STEP		1
-#define HM11B1_DGTL_GAIN_DEFAULT	0x0100
+#define HM11B1_DGTL_GAIN_DEFAULT	0x100
+/* register update control */
+#define HM11B1_REG_COMMAND_UPDATE	0x104
 
 /* Test Pattern Control */
 #define HM11B1_REG_TEST_PATTERN		0x0601
@@ -395,299 +399,6 @@ static const struct hm11b1_reg sensor_1292x800_30fps_setting[] = {
 	{0x4004, 0x02},
 };
 
-//RAW 10bit 1292x800_60fps_MIPI 384Mbps/lane
-static const struct hm11b1_reg sensor_1292x800_60fps_setting[] = {
-	{0x0103, 0x00},
-	{0x0102, 0x01},
-	{0x0202, 0x03},
-	{0x0203, 0x7C},
-	{0x0205, 0x20},
-	{0x0207, 0x01},
-	{0x0208, 0x00},
-	{0x0209, 0x01},
-	{0x020A, 0x00},
-	{0x0300, 0x91},
-	{0x0301, 0x0A},
-	{0x0302, 0x02},
-	{0x0303, 0x2E},
-	{0x0304, 0x43},
-	{0x0306, 0x00},
-	{0x0307, 0x00},
-	{0x0340, 0x03},
-	{0x0341, 0x60},
-	{0x0342, 0x05},
-	{0x0343, 0xA0},
-	{0x0344, 0x00},
-	{0x0345, 0x00},
-	{0x0346, 0x03},
-	{0x0347, 0x2F},
-	{0x0350, 0xFF},
-	{0x0351, 0x00},
-	{0x0352, 0x00},
-	{0x0370, 0x00},
-	{0x0371, 0x00},
-	{0x0380, 0x00},
-	{0x0381, 0x00},
-	{0x0382, 0x00},
-	{0x1000, 0xC3},
-	{0x1001, 0xD0},
-	{0x100A, 0x13},
-	{0x2000, 0x00},
-	{0x2061, 0x01},
-	{0x2062, 0x00},
-	{0x2063, 0xC8},
-	{0x2100, 0x03},
-	{0x2101, 0xF0},
-	{0x2102, 0xF0},
-	{0x2103, 0x01},
-	{0x2104, 0x10},
-	{0x2105, 0x10},
-	{0x2106, 0x02},
-	{0x2107, 0x0A},
-	{0x2108, 0x10},
-	{0x2109, 0x15},
-	{0x210A, 0x1A},
-	{0x210B, 0x20},
-	{0x210C, 0x08},
-	{0x210D, 0x0A},
-	{0x210E, 0x0F},
-	{0x210F, 0x12},
-	{0x2110, 0x1C},
-	{0x2111, 0x20},
-	{0x2112, 0x23},
-	{0x2113, 0x2A},
-	{0x2114, 0x30},
-	{0x2115, 0x10},
-	{0x2116, 0x00},
-	{0x2117, 0x01},
-	{0x2118, 0x00},
-	{0x2119, 0x06},
-	{0x211A, 0x00},
-	{0x211B, 0x00},
-	{0x2615, 0x08},
-	{0x2616, 0x00},
-	{0x2700, 0x01},
-	{0x2711, 0x01},
-	{0x272F, 0x01},
-	{0x2800, 0x29},
-	{0x2821, 0xCE},
-	{0x2839, 0x27},
-	{0x283A, 0x01},
-	{0x2842, 0x01},
-	{0x2843, 0x00},
-	{0x3022, 0x11},
-	{0x3024, 0x30},
-	{0x3025, 0x12},
-	{0x3026, 0x00},
-	{0x3027, 0x81},
-	{0x3028, 0x01},
-	{0x3029, 0x00},
-	{0x302A, 0x30},
-	{0x3030, 0x00},
-	{0x3032, 0x00},
-	{0x3035, 0x01},
-	{0x303E, 0x00},
-	{0x3051, 0x00},
-	{0x3082, 0x0E},
-	{0x3084, 0x0D},
-	{0x30A8, 0x03},
-	{0x30C4, 0xA0},
-	{0x30D5, 0xC1},
-	{0x30D8, 0x00},
-	{0x30D9, 0x0D},
-	{0x30DB, 0xC2},
-	{0x30DE, 0x25},
-	{0x30E1, 0xC3},
-	{0x30E4, 0x25},
-	{0x30E7, 0xC4},
-	{0x30EA, 0x25},
-	{0x30ED, 0xC5},
-	{0x30F0, 0x25},
-	{0x30F2, 0x0C},
-	{0x30F3, 0x85},
-	{0x30F6, 0x25},
-	{0x30F8, 0x0C},
-	{0x30F9, 0x05},
-	{0x30FB, 0x40},
-	{0x30FC, 0x25},
-	{0x30FD, 0x54},
-	{0x30FE, 0x0C},
-	{0x3100, 0xC2},
-	{0x3103, 0x00},
-	{0x3104, 0x2B},
-	{0x3106, 0xC3},
-	{0x3109, 0x25},
-	{0x310C, 0xC4},
-	{0x310F, 0x25},
-	{0x3112, 0xC5},
-	{0x3115, 0x25},
-	{0x3117, 0x0C},
-	{0x3118, 0x85},
-	{0x311B, 0x25},
-	{0x311D, 0x0C},
-	{0x311E, 0x05},
-	{0x3121, 0x25},
-	{0x3123, 0x0C},
-	{0x3124, 0x0D},
-	{0x3126, 0x40},
-	{0x3127, 0x25},
-	{0x3128, 0x54},
-	{0x3129, 0x0C},
-	{0x3130, 0x20},
-	{0x3134, 0x60},
-	{0x3135, 0xC2},
-	{0x3139, 0x12},
-	{0x313A, 0x07},
-	{0x313F, 0x52},
-	{0x3140, 0x34},
-	{0x3141, 0x2E},
-	{0x314F, 0x07},
-	{0x3151, 0x47},
-	{0x3153, 0xB0},
-	{0x3154, 0x4A},
-	{0x3155, 0xC0},
-	{0x3157, 0x55},
-	{0x3158, 0x01},
-	{0x3165, 0xFF},
-	{0x316B, 0x12},
-	{0x316E, 0x12},
-	{0x3176, 0x12},
-	{0x3178, 0x01},
-	{0x317C, 0x10},
-	{0x317D, 0x05},
-	{0x317F, 0x07},
-	{0x3182, 0x07},
-	{0x3183, 0x11},
-	{0x3184, 0x88},
-	{0x3186, 0x28},
-	{0x3191, 0x00},
-	{0x3192, 0x20},
-	{0x3400, 0x48},
-	{0x3401, 0x00},
-	{0x3402, 0x03},
-	{0x3403, 0x7D},
-	{0x3404, 0x05},
-	{0x3405, 0x40},
-	{0x3406, 0x00},
-	{0x3407, 0x00},
-	{0x3408, 0x03},
-	{0x3409, 0x2F},
-	{0x340A, 0x00},
-	{0x340B, 0x00},
-	{0x340C, 0x00},
-	{0x340D, 0x00},
-	{0x340E, 0x00},
-	{0x340F, 0x00},
-	{0x3410, 0x00},
-	{0x3411, 0x01},
-	{0x3412, 0x00},
-	{0x3413, 0x03},
-	{0x3414, 0xB0},
-	{0x3415, 0x4A},
-	{0x3416, 0xC0},
-	{0x3418, 0x55},
-	{0x3419, 0x03},
-	{0x341B, 0x7D},
-	{0x341C, 0x00},
-	{0x341F, 0x03},
-	{0x3420, 0x00},
-	{0x3421, 0x02},
-	{0x3422, 0x00},
-	{0x3423, 0x02},
-	{0x3424, 0x01},
-	{0x3425, 0x02},
-	{0x3426, 0x00},
-	{0x3427, 0xA2},
-	{0x3428, 0x01},
-	{0x3429, 0x06},
-	{0x342A, 0xF8},
-	{0x3440, 0x01},
-	{0x3441, 0xBE},
-	{0x3442, 0x02},
-	{0x3443, 0x18},
-	{0x3444, 0x03},
-	{0x3445, 0x0C},
-	{0x3446, 0x06},
-	{0x3447, 0x18},
-	{0x3448, 0x09},
-	{0x3449, 0x24},
-	{0x344A, 0x08},
-	{0x344B, 0x08},
-	{0x345C, 0x00},
-	{0x345D, 0x44},
-	{0x345E, 0x02},
-	{0x345F, 0x43},
-	{0x3460, 0x04},
-	{0x3461, 0x3B},
-	{0x3466, 0xF8},
-	{0x3467, 0x43},
-	{0x347D, 0x02},
-	{0x3483, 0x05},
-	{0x3484, 0x0C},
-	{0x3485, 0x03},
-	{0x3486, 0x20},
-	{0x3487, 0x00},
-	{0x3488, 0x00},
-	{0x3489, 0x00},
-	{0x348A, 0x09},
-	{0x348B, 0x00},
-	{0x348C, 0x00},
-	{0x348D, 0x02},
-	{0x348E, 0x01},
-	{0x348F, 0x40},
-	{0x3490, 0x00},
-	{0x3491, 0xC8},
-	{0x3492, 0x00},
-	{0x3493, 0x02},
-	{0x3494, 0x00},
-	{0x3495, 0x02},
-	{0x3496, 0x02},
-	{0x3497, 0x06},
-	{0x3498, 0x05},
-	{0x3499, 0x04},
-	{0x349A, 0x09},
-	{0x349B, 0x05},
-	{0x349C, 0x17},
-	{0x349D, 0x05},
-	{0x349E, 0x00},
-	{0x349F, 0x00},
-	{0x34A0, 0x00},
-	{0x34A1, 0x00},
-	{0x34A2, 0x08},
-	{0x34A3, 0x08},
-	{0x34A4, 0x00},
-	{0x34A5, 0x0B},
-	{0x34A6, 0x0C},
-	{0x34A7, 0x32},
-	{0x34A8, 0x10},
-	{0x34A9, 0xE0},
-	{0x34AA, 0x52},
-	{0x34AB, 0x00},
-	{0x34AC, 0x60},
-	{0x34AD, 0x2B},
-	{0x34AE, 0x25},
-	{0x34AF, 0x48},
-	{0x34B1, 0x06},
-	{0x34B2, 0xF8},
-	{0x34C3, 0xB0},
-	{0x34C4, 0x4A},
-	{0x34C5, 0xC0},
-	{0x34C7, 0x55},
-	{0x34C8, 0x03},
-	{0x34CB, 0x00},
-	{0x353A, 0x00},
-	{0x355E, 0x48},
-	{0x3572, 0xB0},
-	{0x3573, 0x4A},
-	{0x3574, 0xC0},
-	{0x3576, 0x55},
-	{0x3577, 0x03},
-	{0x357A, 0x00},
-	{0x35DA, 0x00},
-	{0x4003, 0x02},
-	{0x4004, 0x02},
-};
-
 static const char * const hm11b1_test_pattern_menu[] = {
 	"Disabled",
 	"Solid Color",
@@ -842,7 +553,22 @@ static int hm11b1_write_reg_list(struct hm11b1 *hm11b1,
 
 static int hm11b1_update_digital_gain(struct hm11b1 *hm11b1, u32 d_gain)
 {
-	return hm11b1_write_reg(hm11b1, HM11B1_REG_DGTL_GAIN, 2, d_gain);
+	struct i2c_client *client = v4l2_get_subdevdata(&hm11b1->sd);
+	int ret = 0;
+
+	ret = hm11b1_write_reg(hm11b1, HM11B1_REG_DGTL_GAIN, 2, d_gain);
+	if (ret) {
+		dev_err(&client->dev, "failed to set HM11B1_REG_DGTL_GAIN");
+		return ret;
+	}
+
+	ret = hm11b1_write_reg(hm11b1, HM11B1_REG_DGTL_GAIN_IR, 2, d_gain);
+	if (ret) {
+		dev_err(&client->dev, "failed to set HM11B1_REG_DGTL_GAIN_IR");
+		return ret;
+	}
+
+	return ret;
 }
 
 static int hm11b1_test_pattern(struct hm11b1 *hm11b1, u32 pattern)
@@ -877,10 +603,18 @@ static int hm11b1_set_ctrl(struct v4l2_ctrl *ctrl)
 	if (!pm_runtime_get_if_in_use(&client->dev))
 		return 0;
 
+	ret = hm11b1_write_reg(hm11b1, HM11B1_REG_COMMAND_UPDATE, 1, 1);
+	if (ret) {
+		dev_err(&client->dev, "failed to enable HM11B1_REG_COMMAND_UPDATE");
+		pm_runtime_put(&client->dev);
+		return ret;
+	}
 	switch (ctrl->id) {
 	case V4L2_CID_ANALOGUE_GAIN:
 		ret = hm11b1_write_reg(hm11b1, HM11B1_REG_ANALOG_GAIN, 1,
 				       ctrl->val);
+		ret |= hm11b1_write_reg(hm11b1, HM11B1_REG_ANALOG_GAIN_IR, 1,
+					ctrl->val);
 		break;
 
 	case V4L2_CID_DIGITAL_GAIN:
@@ -907,6 +641,7 @@ static int hm11b1_set_ctrl(struct v4l2_ctrl *ctrl)
 		break;
 	}
 
+	ret |= hm11b1_write_reg(hm11b1, HM11B1_REG_COMMAND_UPDATE, 1, 0);
 	pm_runtime_put(&client->dev);
 
 	return ret;
@@ -1305,7 +1040,7 @@ static int hm11b1_probe(struct i2c_client *client)
 		goto probe_error_v4l2_ctrl_handler_free;
 	}
 
-	ret = v4l2_async_register_subdev_sensor(&hm11b1->sd);
+	ret = v4l2_async_register_subdev_sensor_common(&hm11b1->sd);
 	if (ret < 0) {
 		dev_err(&client->dev, "failed to register V4L2 subdev: %d",
 			ret);
diff --git a/drivers/media/i2c/ov01a1s.c b/drivers/media/i2c/ov01a1s.c
index dd299204d9e9..8cd9e2dd4e7e 100644
--- a/drivers/media/i2c/ov01a1s.c
+++ b/drivers/media/i2c/ov01a1s.c
@@ -872,7 +872,7 @@ static int ov01a1s_probe(struct i2c_client *client)
 		goto probe_error_v4l2_ctrl_handler_free;
 	}
 
-	ret = v4l2_async_register_subdev_sensor(&ov01a1s->sd);
+	ret = v4l2_async_register_subdev_sensor_common(&ov01a1s->sd);
 	if (ret < 0) {
 		dev_err(&client->dev, "failed to register V4L2 subdev: %d",
 			ret);